unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, dbf, FileUtil, Forms, Controls, Graphics, Dialogs,
  DBGrids, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    DataSource1: TDataSource;
    Dbf1: TDbf;
    DBGrid1: TDBGrid;
    EdSuche: TEdit;
    Label1: TLabel;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Dbf1FilterRecord(DataSet: TDataSet; var Accept: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Variants, LCLIntf, LConvEncoding, LazUtf8;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Checkbox1.Checked then begin
    Dbf1.Filtered := true;
    Dbf1.Filter := 'Name="' + UTF8ToCP1252(EdSuche.Text) + '*"';
//    Dbf1.Filter := 'Name="' + UTF8ToCP1252(EdSuche.Text) + '*"';
//    Dbf1.OnFilterRecord := @Dbf1FilterRecord;
  end else begin
    Dbf1.Filter := '';
    Dbf1.OnFilterRecord := nil;
    Dbf1.Filtered := false;
    dbf1.Locate('Name', UTF8ToCP1252(EdSuche.Text), [loCaseInsensitive, loPartialKey]);
  end;
end;

procedure TForm1.Dbf1FilterRecord(DataSet: TDataSet; var Accept: Boolean);
var
  s: string;
begin
  s := Dataset.FieldByName('Name').AsString;
  Accept := pos(EdSuche.Text, s) = 1;
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  TableName : String = 'Test';
begin

  dbf1.FilePath := '';
  dbf1.TableName := TABLENAME + '.dbf';

  if not FileExists(dbf1.FilePathFull + dbf1.TableName) then
  begin
    with dbf1.FieldDefs do begin
      Add('Name', ftString, 20, true);
    end;
    dbf1.CreateTable;
    dbf1.Close;
                  (*
    dbf1.Exclusive := True;
    dbf1.Open;
    dbf1.AddIndex('name_idx', 'Name', [ixPrimary, ixCaseInsensitive]);
    dbf1.Close;     *)

    dbf1.Open;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'Meier';
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'Müller';
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'Wächter';
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'Rotkäppchen';
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'Maler';
    dbf1.Post;
  end;

  dbf1.Open;

  Label1.Caption := 'CP' + IntToStr(dbf1.DbfFile.FileCodePage);
end;

end.

